<template>
  <div class="mt-5 content text-center">
    <div class="row w-100 mt-3 h-100 ">
    <nav class=" col-5 col-lg-4 col-xl-3 leftpanel float-left pl-0 pr-0  width   sidebar  " id="sidebar" v-if="serversOnline.length>0 || serversOffline.length>0">
        <leftpanel
          :serversOnline="serversOnline"
          :serversOffline="serversOffline"
          :libraries="libraries"
          :librarySelected="librarySelected"
          :serverselected="serverselected"
          @changeLibrary="(library)=>changeLibrary(library)"
          @changeServer="(server)=>setActive(server)"
          @libraryDeleted="(library)=>removeLibrary(library)"
        ></leftpanel>
      </nav>
        <div class="col  rigthpanel">
          <bookArea :hiddeFilters="hiddeFilters" :server="serverselected" :library="librarySelected" v-if="librarySelected"></bookArea>
          <div v-if="phase=='noServers'">
            <div class="card mt-5 d-flex justify-content-center bg-transparent border-0">
              <span class="mt-2" style="font-size:3vh"><font-awesome-icon class="card-img-top" color="black" size="10x" icon="server"/></span>
              <div class="card-body" v-if="serversOffline.length<0">
                <h3 class="card-text">You need run servers or</h3>
                <h3> get friends to start reading</h3>
              </div>
              <div class="card-body" v-else>
                <h3 class="card-text">No servers online</h3>
              </div>
            </div>
          </div>
          <div v-if="phase=='noLibs'">
            <div class="card mt-5 d-flex justify-content-center bg-transparent border-0">
              <span class="mt-2" style="font-size:3vh"><font-awesome-icon class="card-img-top" color="black" size="10x" icon="swatchbook"/></span>
              <div class="card-body">
                <h3 class="card-text">No libraries at</h3>
                <h3> {{serverselected.name}}</h3>
              </div>
            </div>
          </div>
        </div>
    </div>
    <modalNewLibrary
      @addLibrary="(data)=>addLibrary(data)"
      v-if="serversOnline.length>0"
      :servers="serversOnline"
    ></modalNewLibrary>
  </div>
</template>
<script>
const $ = require("jquery");
import leftpanel from "./LeftPanel";
import bookArea from "./BookArea";
import EventBus from "../../main";
import modalNewLibrary from "../modals/ModalNewLibrary";
export default {
  name: "userboard",
  watch: {},
  components: {
    bookArea,
    leftpanel,
    modalNewLibrary
  },
  directives: {
    focus: {
      inserted: function(el) {
        el.focus();
      }
    }
  },
  beforeDestroy:function(){
    EventBus.$off("toggleSidebar")
  },
  beforeMount: function() {
    EventBus.$on("toggleSidebar",()=>{
      $('.sidebar').toggle(1000)
      var timeout=0
      if(this.hiddeFilters) timeout=1000
      setTimeout(() => {
        this.hiddeFilters=!this.hiddeFilters
      }, timeout);
    })
    this.$socket.on("connect", () => {
      this.isConnected = true;
    });
    this.$socket.emit("reqServers", {
      token: localStorage.getItem("jwt"),
      userId: this.user.id
    });
    this.$socket.on("resServers", servers => {
      this.serversOnline = [];
      this.serversOffline = [];
      this.libraries=[]
      this.serverselected=null
      this.librarySelected=null
      if (servers.length > 0) {
        servers.forEach(server => {
          this.phase=''
          if (server.isConected) this.serversOnline.push(server);
          else this.serversOffline.push(server);
        });
        if(this.serversOnline.length>0){
          this.serverselected = this.serversOnline[0];
        } else this.phase='noServers'
        this.reqLibraries();
      }else this.phase='noServers'
    });
    this.$socket.on("resLibraries", libraries => {
      this.phase=''
      if (libraries != undefined && libraries.length > 0) {
        this.libraries = libraries;
        this.librarySelected = this.libraries[0];
        this.newName = this.librarySelected.name;
        this.reqBooks();
      }else{
        this.phase='noLibs'
      }
    });
    this.$socket.on("serverUpdateStatus", data => {
      this.phase==''
      if (data.status) {
        this.$toastr.info(
          "Server " + data.server.name + " is now online",
          "Server Connected",
          {
            preventDuplicates: true,
            progressBar: true,
            positionClass: "toast-bottom-right"
          }
        );
      } else {
        this.$toastr.error(
          "Server " + data.server.name + " is now offline",
          "Server Dissconnected",
          {
            preventDuplicates: true,
            progressBar: true,
            positionClass: "toast-bottom-right"
          }
        );
      }
      setTimeout(() => {
          this.$socket.emit("reqServers", {
            token: localStorage.getItem("jwt"),
            userId: this.user.id
          });
      }, 30);
    });
    this.$socket.on('updateSharedLibrary',data=>{
      if(data.add){
        this.phase=''
        var srv=this.serversOnline.filter((s)=>s.id==data.server.id)
        if(srv.length==0) this.serversOnline.push(data.server)
        if(this.serversOnline.length==1) this.serverselected=this.serversOnline[0]
        this.addLibrary({library:data.library,serverId:data.server.id})

        this.$toastr.info(
          data.user.name +" is sharing  " + data.library.name + " with you",
          "Shared library",
          {
            preventDuplicates: true,
            progressBar: true,
            positionClass: "toast-bottom-right"
          }
        );

      }else{
        if(this.libraries.length=0) this.phase='noLibs'
        this.$toastr.error(
          data.user.name +" stop sharing  " + data.library.name + " with you",
          "UnsharedLibrary",
          {
            preventDuplicates: true,
            progressBar: true,
            positionClass: "toast-bottom-right"
          }
        );

        if(this.serverselected.id==data.server.id && this.libraries.length>1){
          if(this.libraries.length>2) this.changeLibrary(this.libraries[0])
          this.libraries.forEach(library=>{
            if(library._id==data.library._id) this.libraries.splice(this.libraries.indexOf(library),1)
          })

        }else{
          this.$socket.emit("reqServers", {
            token: localStorage.getItem("jwt"),
            userId: this.user.id
          });
        }
      }
    })
    this.$socket.on("disconnect", () => (this.isConnected = false));
  },

  data() {
    return {
      user: JSON.parse(localStorage.getItem("user")),
      isConnected: this.$socket.connected,
      libraries: [],
      serversOnline: [],
      serversOffline: [],
      serverselected: null,
      librarySelected: null,
      hiddeFilters:false,
      phase:'',
    };
  },

  computed: {
    status: ref => {
      if (this.isConnected == true) return "text-info";
      else return "text-danger";
    }
  },

  methods: {
    setActive: function(server) {
      this.phase=''
      this.serverselected = server;
      this.libraries = [];
      this.librarySelected = null;
      this.reqLibraries();
    },
    reqBooks: function() {
      EventBus.$emit("waitingBooksResponse"),
      this.$socket.emit("reqBooks", {
        token: localStorage.getItem("jwt"),
        id: this.user.id,
        serverId: this.serverselected.id,
        library: this.librarySelected
      });
    },

    reqLibraries() {
      if (this.serverselected) {
        this.phase=''
        this.$socket.emit("reqLibraries", {
          token: localStorage.getItem("jwt"),
          userId: this.user.id,
          server: this.serverselected
        });
      }
    },

    changeLibrary(library) {
      if (!this.isRenaming) {
        this.phase=''
        this.librarySelected = library;
        this.newName = this.librarySelected.name;
        this.reqBooks();
      }
    },
    //deletes a library in view after it's deleted in server
     removeLibrary(library) {
      this.libraries.forEach((lib, key) => {
        if (lib._id == library._id) this.libraries.splice(key, 1);
      });
      if(this.librarySelected._id==library._id){
        if (this.libraries.length == 0){ //if not more libraries at server
          if(this.user.id!==this.serverselected.userId) { //if server not own server remove
                this.$socket.emit("reqServers", {
                token: localStorage.getItem("jwt"),
                userId: this.user.id
              });
          }
          this.librarySelected = null
          if(this.serversOnline.length>0){ //if there are another server online seclt first
             this.setActive(this.serversOnline[0])
          }
        } else{
          this.changeLibrary(this.libraries[0]);
        }
      }
    },

    addLibrary(data) {
      this.phase=''
      if (data.serverId == this.serverselected.id) {
        this.libraries.push(data.library);
        if (this.libraries.length == 1) {
          this.changeLibrary(data.library);
        }
      }
    }
  }
};
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style >
.content{
  overflow-y: hidden;

}

.input-border-less-name {
  background-color: transparent;
  border-width: 0px !important;
  outline: 0px !important;
  width: 98%;
}

.leftpanel {
  min-height: 75 !important;
  background-color: #f6f8fa;

  height: 75vh !important;
overflow-y: auto;
  padding: 2rem;
}
.rigthpanel {
  position: relative;
  height: 75vh !important;
overflow-y: auto
}
.disabled {
  pointer-events: none;
  background-color: lightgray;
}

.libraryselected {
  background-color: lightskyblue;
}
.library:hover {
  background-color: lightblue;
}
@media (min-width: 576px) {
  .sidebar{
    display: none;

  }
 }
@media (min-width: 768px) {
  .sidebar{
    display: none;
  }
 }
@media (min-width: 992px) {
  .sidebar{
    display: block
  }
 }
@media (min-width: 1200px) {
  .sidebar{
 display: block
  }
 }
 resize-enter-active, .fade-leave-active {
  transition: opacity 0.25s ease-out;
}
</style>
